#!/usr/bin/env python

'''
Simple passwd test
'''

import pexpect, string, time
import crypt, getpass, pwd, os

def create_user(user):
    user = "useradd %s" % user
    os.system (user)  

def del_user(user):
    user = "userdel %s" % user
    os.system (user)

def change_passwd(user, password):
   child = pexpect.spawn ('passwd %s' % user)
   child.expect ('New password: ')
   child.sendline (password)
   child.expect ('Re-enter new password: ')
   child.sendline (password)
   return

def read_passwd(user):
   passwd = open('/etc/passwd')
   for line in passwd.readlines():
      rec = string.splitfields(line, ':')
      if rec[0] == user:
         pass_passwd = rec[1]
   passwd.close()
   print pass_passwd
   return pass_passwd

def main_test():
   user = "passwd_test_user"
   password = "password"
   en_pass = ""
   pass_passwd = ""
   create_user(user)
   change_passwd(user, password)
   pass_passwd = read_passwd(user)
   salt = pass_passwd [0:2]
   en_pass = crypt.crypt(password, salt)
   print en_pass
   print pass_passwd
   del_user(user)
   
   if en_pass == pass_passwd:
      print "PASS"
      return 0
   else:
      print "FAIL"
      return 1
   

if __name__ == "__main__":
    main_test()
